package kr.co.vividnext.sodalive.admin.calculate

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/calculate")
class AdminCalculateController(private val service: AdminCalculateService) {
    @GetMapping("/live")
    fun getCalculateLive(
        @RequestParam startDateStr: String,
        @RequestParam endDateStr: String
    ) = ApiResponse.ok(service.getCalculateLive(startDateStr, endDateStr))
}
