package kr.co.vividnext.sodalive.admin.content

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/audio-content")
class AdminContentController(private val service: AdminContentService) {
    @GetMapping("/list")
    fun getAudioContentList(pageable: Pageable) = ApiResponse.ok(service.getAudioContentList(pageable))

    @GetMapping("/search")
    fun searchAudioContent(
        @RequestParam(value = "search_word") searchWord: String,
        pageable: Pageable
    ) = ApiResponse.ok(service.searchAudioContent(searchWord, pageable))

    @PutMapping
    fun modifyAudioContent(
        @RequestBody request: UpdateAdminContentRequest
    ) = ApiResponse.ok(service.updateAudioContent(request))
}
