package kr.co.vividnext.sodalive.can.charge

import com.fasterxml.jackson.annotation.JsonProperty
import kr.co.vividnext.sodalive.can.payment.PaymentGateway

data class ChargeRequest(val canId: Long, val paymentGateway: PaymentGateway)

data class ChargeResponse(val chargeId: Long)

data class VerifyRequest(
    @JsonProperty("receipt_id")
    val receiptId: String,
    @JsonProperty("order_id")
    val orderId: String
)

data class VerifyResult(
    @JsonProperty("receipt_id")
    val receiptId: String,
    val method: String,
    val status: Int,
    val price: Int
)

data class AppleChargeRequest(
    val title: String,
    val chargeCan: Int,
    val paymentGateway: PaymentGateway,
    var price: Double? = null,
    var locale: String? = null
)

data class AppleVerifyRequest(val receiptString: String, val chargeId: Long)

data class AppleVerifyResponse(val status: Int)
